package org.wfc.omada.api.sitesetting.model;

import com.fasterxml.jackson.annotation.JsonProperty;
import io.swagger.annotations.ApiModelProperty;

import javax.validation.Valid;
import javax.validation.constraints.NotNull;
import java.util.ArrayList;
import java.util.List;
import java.util.Objects;

/**
 * BatchModifyVoipDeviceSettingEntity
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.SpringCodegen", date = "2024-12-04T11:32:19.054+08:00[Asia/Shanghai]")

public class BatchModifyVoipDeviceSettingEntity   {
  @JsonProperty("deviceMacList")
  @Valid
  private List<String> deviceMacList = new ArrayList<>();

  @JsonProperty("voipDeviceConfiguration")
  private BatchModifyVoipDeviceConfigurationEntity voipDeviceConfiguration;

  @JsonProperty("telephoneNumberAdvancedSetting")
  private TelephoneNumberAdvancedSettingApOpenApiVo telephoneNumberAdvancedSetting;

  @JsonProperty("skipConfirm")
  private Boolean skipConfirm;

  public BatchModifyVoipDeviceSettingEntity deviceMacList(List<String> deviceMacList) {
    this.deviceMacList = deviceMacList;
    return this;
  }

  public BatchModifyVoipDeviceSettingEntity addDeviceMacListItem(String deviceMacListItem) {
    this.deviceMacList.add(deviceMacListItem);
    return this;
  }

  /**
   * Device MAC list.
   * @return deviceMacList
  */
  @ApiModelProperty(required = true, value = "Device MAC list.")
  @NotNull


  public List<String> getDeviceMacList() {
    return deviceMacList;
  }

  public void setDeviceMacList(List<String> deviceMacList) {
    this.deviceMacList = deviceMacList;
  }

  public BatchModifyVoipDeviceSettingEntity voipDeviceConfiguration(BatchModifyVoipDeviceConfigurationEntity voipDeviceConfiguration) {
    this.voipDeviceConfiguration = voipDeviceConfiguration;
    return this;
  }

  /**
   * Get voipDeviceConfiguration
   * @return voipDeviceConfiguration
  */
  @ApiModelProperty(value = "")

  @Valid

  public BatchModifyVoipDeviceConfigurationEntity getVoipDeviceConfiguration() {
    return voipDeviceConfiguration;
  }

  public void setVoipDeviceConfiguration(BatchModifyVoipDeviceConfigurationEntity voipDeviceConfiguration) {
    this.voipDeviceConfiguration = voipDeviceConfiguration;
  }

  public BatchModifyVoipDeviceSettingEntity telephoneNumberAdvancedSetting(TelephoneNumberAdvancedSettingApOpenApiVo telephoneNumberAdvancedSetting) {
    this.telephoneNumberAdvancedSetting = telephoneNumberAdvancedSetting;
    return this;
  }

  /**
   * Get telephoneNumberAdvancedSetting
   * @return telephoneNumberAdvancedSetting
  */
  @ApiModelProperty(value = "")

  @Valid

  public TelephoneNumberAdvancedSettingApOpenApiVo getTelephoneNumberAdvancedSetting() {
    return telephoneNumberAdvancedSetting;
  }

  public void setTelephoneNumberAdvancedSetting(TelephoneNumberAdvancedSettingApOpenApiVo telephoneNumberAdvancedSetting) {
    this.telephoneNumberAdvancedSetting = telephoneNumberAdvancedSetting;
  }

  public BatchModifyVoipDeviceSettingEntity skipConfirm(Boolean skipConfirm) {
    this.skipConfirm = skipConfirm;
    return this;
  }

  /**
   * skipConfirm indicates whether to skip the query of \"#'s conflict\" of voip device settings. false: Not to skip the query. true: Skip the query and the device(s) will give priority to the \"end with #\" configuration. 
   * @return skipConfirm
  */
  @ApiModelProperty(required = true, value = "skipConfirm indicates whether to skip the query of \"#'s conflict\" of voip device settings. false: Not to skip the query. true: Skip the query and the device(s) will give priority to the \"end with #\" configuration. ")
  @NotNull


  public Boolean getSkipConfirm() {
    return skipConfirm;
  }

  public void setSkipConfirm(Boolean skipConfirm) {
    this.skipConfirm = skipConfirm;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    BatchModifyVoipDeviceSettingEntity batchModifyVoipDeviceSettingEntity = (BatchModifyVoipDeviceSettingEntity) o;
    return Objects.equals(this.deviceMacList, batchModifyVoipDeviceSettingEntity.deviceMacList) &&
        Objects.equals(this.voipDeviceConfiguration, batchModifyVoipDeviceSettingEntity.voipDeviceConfiguration) &&
        Objects.equals(this.telephoneNumberAdvancedSetting, batchModifyVoipDeviceSettingEntity.telephoneNumberAdvancedSetting) &&
        Objects.equals(this.skipConfirm, batchModifyVoipDeviceSettingEntity.skipConfirm);
  }

  @Override
  public int hashCode() {
    return Objects.hash(deviceMacList, voipDeviceConfiguration, telephoneNumberAdvancedSetting, skipConfirm);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class BatchModifyVoipDeviceSettingEntity {\n");
    
    sb.append("    deviceMacList: ").append(toIndentedString(deviceMacList)).append("\n");
    sb.append("    voipDeviceConfiguration: ").append(toIndentedString(voipDeviceConfiguration)).append("\n");
    sb.append("    telephoneNumberAdvancedSetting: ").append(toIndentedString(telephoneNumberAdvancedSetting)).append("\n");
    sb.append("    skipConfirm: ").append(toIndentedString(skipConfirm)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
}

